#!/bin/bash

# popis parametrov:
# 1 - cislo kompresie: 1 - ZIP, 2 - TAR, 3 - TAR+GZIP
# 2 - spakovany subor so zadanim
# 3 - pracovny adresar (kontrolny bez /)
# 4 - vystupny adresar (logy a vysledky bez /)
# 5 - cesta k programom (zakoncena /)
# 6 - ak je 1, potom rozbalenie, inak len kontrola

# funkcia na upratanie kontrolneho adresara a skopirovanie vysledkov, ocakava 3 argumenty - prac. adresar, vysl. adr.  a verdikt
orig=`pwd`
binadr=$5
# pwd nedava lomitko na koniec
function cleanup ()
	{
	cp *.err $orig/$2
	cp *.out $orig/$2
	cp *.html $orig/$2
	cd $orig
	rm -f -r $1
	p=$2/result.txt
	echo "$3" >$p
	if ((sembl == 1))
		then
		$binadr'sblock'  $sempath -
	fi
	exit 1
	}

#priznak obsadenia semaforu
sembl=0

if ((${6} == 1))
	then

	# vytvorenie adresarov
	rm -f -r $3
	rm -f -r $4

	mkdir $3
	mkdir $4

	echo "deny from all" >$3/.htaccess
	echo "deny from all" >$4/.htaccess

	cd $3

	cd ..
	sempath=`pwd`

	cd $orig
	cd $3

	# zaciatok pripravy noveho root-u
	mkdir nr

	# prekopirovanie zadania
	cd nr
	cp $orig/$2 .


	#rozbalenie ZIP
	if (($1 == 1))
		then
		unzip *.zip  >zip.out 2>&1
		if (($?!=0))
			then
			cleanup $3 $4 "Chyba rozbalenia unzip"
		fi
	fi

	#rozbalenie TAR
	if (($1==2))
		then
		tar -x <*.tar >tar.out 2>&1
		if (($?!=0))
			then
			cleanup $3 $4 "Chyba rozbalenia tar"
		fi
	fi

	#rozbalenie TAR+GZIP
	if (($1==3))
		then
		tar -x -z <*.tar.gz >tar.out 2>&1
		if (($?!=0))
			then
			cleanup $3 $4 "Chyba rozbalenia tar+gzip"
		fi
	fi

chmod -R u+rw *
ls -1R --color=never --indicator-style=none >files_67464_287465_qkdfh_pppp_krrmvjsi
# tu niekde by mohla byt kontrola obsahu archivu
exit 0
fi

cd $3

cd ..
sempath=`pwd`

cd $orig
cd $3/nr

#zaradime sa do fronty
$orig/$5sblock $sempath +
if (($?!=0))
	then
	cleanup $3 $4 "Interna chyba systemu - problem s frontou kontroly zadani"
fi

sembl=1

#priprava pred kompilaciou
#zmazeme pripadne odoslane spustitelne zadanie
rm -f zadanie

#kontrola prikazov generovanych make
make -n >make_cmds
$orig/$5make_test <make_cmds >mt
if (($?!=0))
	then
	mv mt make_test.out
	cleanup $3 $4 "program make by pri kompilacii vygeneroval nepovolene prikazy!"
fi


# kompilacia
make >make.out 2>&1
if (($?!=0))
	then
	cleanup $3 $4 "Chyba pri kompilacii"
fi

# vlastna kontrola

# priprava filesystemu pracovneho

echo >time_cfg 60 chroot -t 50 -m 64000000 -f 50000000
$orig/$5efs2rfs_prep_f32

#zalohujeme pracovny EFS

cp *.f?? ..

# odstranime zoznamy suborov
mv _to_check* ..

# vytvorenie adresarov pre novy root

mkdir bin
mkdir lib
mkdir dev

# nakopirovanie potrebnych dynam. kniznic a programov

cp $orig/$5runner bin
cp /bin/chmod bin
cp /usr/bin/du bin

ldd bin/runner >dyn_libs
ldd zadanie >>dyn_libs
ldd /bin/chmod >>dyn_libs
ldd /usr/bin/du >>dyn_libs


echo "#! /bin/bash" >dlcp_script.sh
$orig/$5ldd_pars lib <dyn_libs >>dlcp_script.sh

chmod a+x dlcp_script.sh
./dlcp_script.sh

rm -f dlcp_script.sh dyn_libs make_cmds mt time_cfg

# spustime zadanie
chmod a+x _to_run
./_to_run >runner.out 2>&1
rslt=$?

# zmenime prava --- bezalo to pod root-om
sudo /usr/sbin/chroot `pwd` chmod -R a+rw *

# ak navr. h. >0 -- zadanie preplnilo disk
if (($rslt > 0 ))
	then
	rm -f *.out *.html *.err
	cleanup $3 $4 "Zadanie vytvorilo prilis velky vystup (>10M)"
fi
# skontrolujeme

mv ../_to_check* .

#obnovime povodny pracovny EFS --- co ak ho zadanie nejako pobabralo?
cp -f ../*.f?? .

$orig/$5runner 180 $orig/$5efs2rfs_check_f32
r=$?

# vysledky vyhodime do nadrad. adr.
# cp *.err ..
# cp *.out ..
# cp *.html ..

if (($r==0))
	then
	cleanup $3 $4 "Zadanie preslo kontrolou"
else
	cleanup $3 $4 "Zadanie nepreslo kontrolou"
fi
